zombie={}

function zombie.new(_hab,_x,_y,_flip)
    return {hab=_hab,x=_x,y=_y,flip=_flip,frame=0,wait=0,step=0,hit=zombie.hit,update=zombie.update_normal, draw=zombie.draw,jumpfwd=false,anim={16,17,16,18},bb={x=4,y=0,w=8,h=16}}
end

function zombie:draw()
    if self.frame>0 then draw.surf((self.frame&7)*16,(self.frame>>3)*16,16,16,self.x,self.y,16,16,self.flip) end
end

function zombie:update_normal()
    self.wait=self.wait+1

    if self.wait==6 then
        self.wait=0
        self.step=(self.step+1)%4
        self.frame=self.anim[self.step+1]

        local inc=12 if self.flip then inc=2 end
        if not self.flip and self.x==84 then
            self.hab=self.hab+1
            self.x=-4
        elseif check_tile(self.hab,self.x+inc,self.y+14)<tiletype.block and check_tile(self.hab,self.x+inc,self.y+16)~=tiletype.void then
            if self.flip then
                self.x=self.x-2
            else
                self.x=self.x+2
            end
            if self.x<-4 then
                self.hab=self.hab-1
                self.x=84
            end
        else
            self.flip=not self.flip
        end

        if self.hab==abad.hab then
            if aabb(abad,self) then
                abad_hurt(1)
            end
        end

        --if check_tile(self.hab,self.x+4,self.y+16)==tiletype.void and ((self.x+4)&7==0 or check_tile(self.hab,self.x+12,self.y+16)==tiletype.void) then
        --    self.flip=not self.flip
        --end
    end
end

function zombie:update_hit()
    self.wait=self.wait+1

    if self.wait==6 then
        self.wait=0
        self.step=self.step+1
        if self.step<40 then
            if self.step%2==0 then
                self.frame=16
            else
                self.frame=-1
            end
        elseif self.step>=40 then
            self.step=0
            self.wait=0
            self.update=zombie.update_normal
        end
    end
end

function zombie:hit()
    self.update=zombie.update_hit
end
